<?php
/*******************************************\
*				Functions					*
*			Spam Decimator 1.5.1			*
*											*
\*******************************************/

function delete_spam_threads($spammerinfo, $settingdelete = 0, &$count)
{
	global $vbulletin;
	
	$spammerid = $spammerinfo['userid'];
	$dolog = true;
	$usecache = true;
	$affectedForums = array();
	$spammerthreads = $vbulletin->db->query_read("SELECT threadid,forumid FROM ".TABLE_PREFIX."thread WHERE postuserid='".$spammerid."'");
	while($spamthread = $vbulletin->db->fetch_array($spammerthreads))
	{
		$spamthreadinfo = fetch_threadinfo($spamthread['threadid'], $usecache);
		$spamforuminfo = fetch_foruminfo($spamthread['forumid'], $usecache);
		$delinfo = array('userid' => $vbulletin->userinfo['userid'], 'username' => $vbulletin->userinfo['username'], 'reason' => 'Spam killed by Spam Decimator Version 1.5', 'keepattachments' => '0');
		delete_thread($spamthread['threadid'], $spamforuminfo['countposts'], $settingdelete, $delinfo, $dolog, $spamthreadinfo);
		if(!in_array($spamthread['forumid'],$affectedForums))
		{
			$affectedForums[] = $spamthread['forumid'];
		}
		$count++;
	}
	//rebuild forum counters
	foreach($affectedForums AS $forum)
	{
		build_forum_counters($forum);
	}
}

function delete_spam_posts($spammerinfo, $settingdelete = 0, &$count)
{
	global $vbulletin;
		
	$spammerid = $spammerinfo['userid'];
	$spammerposts = $vbulletin->db->query_read("SELECT postid,threadid FROM ".TABLE_PREFIX."post WHERE userid='".$spammerid."'");
	$dolog = true;
	$usecache = true;
	$affectedForums = array();
	$affectedThreads = array();
	while($spampost = $vbulletin->db->fetch_array($spammerposts))
	{
		$spampostthreadid = intval($spampost['threadid']);
		$spamthreadinfo = fetch_threadinfo($spampostthreadid, $usecache);
		if($spamthreadinfo['visible'] != 0)
		{
			//thread already deleted, pointless to delete posts as well
			$spamforuminfo = fetch_foruminfo($spamthreadinfo['forumid'], $usecache);
			$delinfo = array('userid' => $vbulletin->userinfo['userid'], 'username' => $vbulletin->userinfo['username'], 'reason' => 'Spam killed by Spam Decimator Version 1.5', 'keepattachments' => '0');
			delete_post($spampost['postid'], $spamforuminfo['countposts'], $spampost['threadid'], $settingdelete, $delinfo, $dolog);
			if(!in_array($spamthreadinfo['forumid'],$affectedForums))
			{
				$affectedForums[] = $spamthreadinfo['forumid'];
			}
			if(!in_array($spampost['threadid'],$affectedThreads))
			{
				$affectedThreads[] = $spampost['threadid'];
			}
			$count++;
		}
	}
	foreach($affectedForums AS $forum)
	{
		build_forum_counters($forum);
	}
	foreach($affectedThreads AS $thread)
	{
		build_thread_counters($thread);
	}
}

function delete_blog_entries($spammerinfo, &$count)
{
	global $vbulletin;
	
	$spammerid = $spammerinfo['userid'];
	//two step process, find them, kill them...
	
	//first...find...
	$spamcomments = $vbulletin->db->query_read("SELECT blogtextid,blogid FROM " .
					"".TABLE_PREFIX."blog_text WHERE userid=$spammerid AND " .
					"state IN ('visible', 'moderation')");
					
	
	$blogids = array();
	while($spamentry = $vbulletin->db->fetch_array($spamcomments))
	{
		//log
		$id = $spamentry['blogtextid'];
		if(!in_array($spamentry['blogid'],$blogids))
		{
			$blogids[] = $spamentry['blogid'];
		}
		
		$vbulletin->db->query_write("INSERT INTO ".TABLE_PREFIX."blog_deletionlog " .
					"(primaryid, type, userid, username, reason, dateline) " .
					"values($id, 'blogtextid', " . $vbulletin->userinfo['userid'] ."," .
					"'" . $vbulletin->userinfo['username'] . "', 'Decimated spam', ".TIMENOW.")");
		$count++;
	}
	
	$vbulletin->db->query_write("UPDATE ".TABLE_PREFIX."blog_text SET " .
								"state='deleted' WHERE userid=$spammerid");
								
	//update counters
	foreach($blogids AS $blogid)
	{
		build_blog_entry_counters($blogid);
	}
}

function check_ips($spampostinfo, &$outputinfo, $spammerinfo)
{
	global $vbulletin;
	$potentials = $vbulletin->db->query_read("SELECT username FROM ".TABLE_PREFIX."post WHERE ipaddress = '".$spampostinfo[ipaddress]."'");
	while($potentialusermatch = $vbulletin->db->fetch_array($potentials))
	{
		if($potentialusermatch['username'] != $spampostinfo['username'])
		{
			if(!in_array($potentialusermatch['username'], $outputinfo))
			{
				$outputinfo[] = $potentialusermatch['username'];
			}
		}
		//else: do nothing, user is the spammer, so IP has to match (DUH!)
	}
	
	unset($potentialusermatch);
	unset($potentials);
	$potentials = $vbulletin->db->query_read("SELECT username FROM ".TABLE_PREFIX."user WHERE ipaddress = '".$spammerinfo[ipaddress]."'");
	while($potentialusermatch = $vbulletin->db->fetch_array($potentials))
	{
		//searching registration IP's this time
		if($potentialusermatch['username'] != $spammerinfo['username'])
		{
			if(!in_array($potentialusermatch['username'], $outputinfo))
			{
				$outputinfo[] = $potentialusermatch['username'];
			}
		}
		//else: do nothing, user is the spammer, so IP has to match (DUH!)
	}
}

function move_spam_threads($movetoid, $spammerinfo, &$count)
{
	global $vbulletin;
		
	$usecache = true;
	$destforuminfo = fetch_foruminfo($movetoid, $usecache);
	$spammerthreads = $vbulletin->db->query_read("SELECT threadid,forumid,title FROM ".TABLE_PREFIX."thread WHERE postuserid='".$spammerinfo[userid]."'");
	while($spamthread = $vbulletin->db->fetch_array($spammerthreads))
	{
		unset($spamforuminfo);
		$usecache = true;
		$spamforuminfo = fetch_foruminfo($spamthread['forumid'], $usecache);
		// update forumid/notes and unstick to prevent abuse
		$vbulletin->db->query("
			UPDATE " . TABLE_PREFIX . "thread SET
			title = '" . addslashes($spamthread['title']) . "',
			forumid = " . intval($destforuminfo['forumid']) . ",
			sticky = 0
			WHERE threadid = $spamthread[threadid]
		");

		build_forum_counters($spamthread['forumid']);
		build_forum_counters($destforuminfo['forumid']);
		$count++;
	}
}
?>